Subject: Re: Can I limit number of rx queues for igb (and other Intel drivers)?

From: Ben Greear <[email-masked]>
Date: Tue, 22 Jun 2010 12:54:20 -0700

On 06/21/2010 04:35 PM, Wyborny, Carolyn wrote:
>
>
>> -----Original Message-----
>> From: [email-masked]
>> [mailto:[email-masked]] On Behalf Of Ben Greear
>> Sent: Friday, June 18, 2010 3:40 PM
>> To: NetDev
>> Subject: Can I limit number of rx queues for igb (and other
>> Intel drivers)?
>>
>> I'm using pktgen to send a stream of packets with varying
>> source and destination
>> IP addresses.  It appears that the fancy rx logic of the NIC
>> (I'm using igb for this test)
>> causes the received packets to appear on random rx queues and
>> so be received out
>> of order in the network core.
>>
>> I do not see the out-of-order issue when using a single
>> source/dest IP address
>> for the pktgen packets.
>>
>> So, is there a way to tell igb to use only a single rx queue?
>>
>> Thanks,
>> Ben
>>
>> --
>> Ben Greear<[email-masked]>
>> Candela Technologies Inc  http://www.candelatech.com
>>
>> --
>> To unsubscribe from this list: send the line "unsubscribe netdev" in
>> the body of a message to [email-masked]
>> More majordomo info at  http://vger.kernel.org/majordomo-info.html
>>
> Hello,
>
> There is not a way to tell igb to use a single queue and ethtool does not currently have a way to do this.
>
> We also maintain an out of kernel version of the driver at SourceForge that has module parameters to do this.
>
> If you need to do this with the kernel version, we'd need to modify ethtool to be able to do this.

A module parameter would be OK, but an ethtool command to change this live
would be really nice!  It may be a day or two before I get back to testing
this, but will try your out-of-tree driver with proper mod-parm invocation
then.

Thanks,
Ben

-- 
Ben Greear <[email-masked]>
Candela Technologies Inc  http://www.candelatech.com